searchData={"items":[{"type":"task","title":"mix wac.install","doc":"Generates schemas, migrations, and contexts for users with WebauthnComponents as the primary authentication mechanism.","ref":"Mix.Tasks.Wac.Install.html"},{"type":"module","title":"Wac.Gen.Contexts","doc":"Functions for generating a User schema and migration.","ref":"Wac.Gen.Contexts.html"},{"type":"function","title":"Wac.Gen.Contexts.copy_template/2","doc":"","ref":"Wac.Gen.Contexts.html#copy_template/2"},{"type":"function","title":"Wac.Gen.Contexts.copy_templates/1","doc":"","ref":"Wac.Gen.Contexts.html#copy_templates/1"},{"type":"module","title":"Wac.Gen.Fixtures","doc":"Functions for generating a User schema and migration.","ref":"Wac.Gen.Fixtures.html"},{"type":"function","title":"Wac.Gen.Fixtures.copy_template/2","doc":"","ref":"Wac.Gen.Fixtures.html#copy_template/2"},{"type":"function","title":"Wac.Gen.Fixtures.copy_templates/1","doc":"","ref":"Wac.Gen.Fixtures.html#copy_templates/1"},{"type":"module","title":"Wac.Gen.Migrations","doc":"Functions for generating a User schema and migration.","ref":"Wac.Gen.Migrations.html"},{"type":"function","title":"Wac.Gen.Migrations.copy_template/2","doc":"","ref":"Wac.Gen.Migrations.html#copy_template/2"},{"type":"function","title":"Wac.Gen.Migrations.copy_templates/1","doc":"","ref":"Wac.Gen.Migrations.html#copy_templates/1"},{"type":"module","title":"Wac.Gen.Schemas","doc":"Functions for generating a User schema and migration.","ref":"Wac.Gen.Schemas.html"},{"type":"function","title":"Wac.Gen.Schemas.copy_template/2","doc":"","ref":"Wac.Gen.Schemas.html#copy_template/2"},{"type":"function","title":"Wac.Gen.Schemas.copy_templates/1","doc":"","ref":"Wac.Gen.Schemas.html#copy_templates/1"},{"type":"module","title":"Wac.Gen.Tests","doc":"Functions for generating a User schema and migration.","ref":"Wac.Gen.Tests.html"},{"type":"function","title":"Wac.Gen.Tests.copy_template/2","doc":"","ref":"Wac.Gen.Tests.html#copy_template/2"},{"type":"function","title":"Wac.Gen.Tests.copy_templates/1","doc":"","ref":"Wac.Gen.Tests.html#copy_templates/1"},{"type":"module","title":"WebauthnComponents.AuthenticationComponent","doc":"A LiveComponent for authentication via WebAuthn API.\n\n> Authentication = Sign In\n\nAuthentication is the process of matching a registered key to an existing user.\n\nWith Passkeys, the user is presented with a native modal from the browser or OS.\n\n- If the user has only one passkey registered to the application's origin URL, they will be prompted to confirm acceptance via biometric ID (touch, face, etc.), OS password, or an OS PIN.\n- If multiple accounts are registered to the device for the origin URL, the user may select an account to use for the current session.\n\nSee [USAGE.md](./USAGE.md) for example code.","ref":"WebauthnComponents.AuthenticationComponent.html"},{"type":"module","title":"Cross-Device Authentication - WebauthnComponents.AuthenticationComponent","doc":"When a user attempts to authenticate on a device where their Passkey is **not** stored, they may scan a QR code to use a cloud-sync'd Passkey.\n\n#","ref":"WebauthnComponents.AuthenticationComponent.html#module-cross-device-authentication"},{"type":"module","title":"Example - WebauthnComponents.AuthenticationComponent","doc":"Imagine a user, Amal, registers a Passkey for example.com on their iPhone and it's stored in iCloud. When they attempt to sign into example.com on a non-Apple device or any browser which cannot access their OS keychain, they may choose to scan a QR code using their iPhone. Assuming the prompts on the iPhone are successful, the other device will be authenticated using the same web account which was initially registered on the iPhone.\n\nWhile this example refers to Apple's Passkey implementation, the process on other platforms may vary. Cross-device credential managers like 1Password may provide a more seamless flow for users who are not constrained to one OS or browser.","ref":"WebauthnComponents.AuthenticationComponent.html#module-example"},{"type":"module","title":"Assigns - WebauthnComponents.AuthenticationComponent","doc":"- `@challenge`: (Internal) A `Wax.Challenge` struct created by the component, used to request an existing credential in the client.\n- `@class` (Optional) CSS classes for overriding the default button style.\n- `@disabled` (Optional) Set to `true` when the `SupportHook` indicates WebAuthn is not supported or enabled by the browser. Defaults to `false`.\n- `@id` (Optional) An HTML element ID.","ref":"WebauthnComponents.AuthenticationComponent.html#module-assigns"},{"type":"module","title":"Events - WebauthnComponents.AuthenticationComponent","doc":"- `\"authenticate\"`: Triggered when a user clicks the `authenticate` button.\n- `\"authentication-challenge\"`: Sent from the component to the client to request an existing credential registered to the endpoint URL.\n- `\"authentication-attestation\"`: Sent by the client when a credential has been registered to the endpoint URL and activated by the user.\n- `\"error\"` Sent by the client when an error occurs.","ref":"WebauthnComponents.AuthenticationComponent.html#module-events"},{"type":"module","title":"Messages - WebauthnComponents.AuthenticationComponent","doc":"- `{:find_credential, key_id: key_id}`\n  - `key_id` is a raw binary representing the id stored associated with the credential in both the client and server during registration.\n  - The parent LiveView must successfully lookup the user with this data before storing a token and redirecting to another view.\n- `{:error, payload}`\n  - `payload` contains the `message`, `name`, and `stack` returned by the browser upon timeout or other client-side errors.\n\n  Errors should be displayed to the user via [`Phoenix.LiveView.put_flash/3`](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html#put_flash/3). However, some errors may be too technical or cryptic to be useful to users, so the parent LiveView may paraphrase the message for clarity.","ref":"WebauthnComponents.AuthenticationComponent.html#module-messages"},{"type":"function","title":"WebauthnComponents.AuthenticationComponent.handle_event/3","doc":"","ref":"WebauthnComponents.AuthenticationComponent.html#handle_event/3"},{"type":"function","title":"WebauthnComponents.AuthenticationComponent.mount/1","doc":"","ref":"WebauthnComponents.AuthenticationComponent.html#mount/1"},{"type":"function","title":"WebauthnComponents.AuthenticationComponent.render/1","doc":"","ref":"WebauthnComponents.AuthenticationComponent.html#render/1"},{"type":"function","title":"WebauthnComponents.AuthenticationComponent.update/2","doc":"","ref":"WebauthnComponents.AuthenticationComponent.html#update/2"},{"type":"module","title":"WebauthnComponents.CoseKey","doc":"Custom `Ecto.Type` for WebAuthn cose keys.\n\nUse this type for the `:public_key` field in an Ecto schema.","ref":"WebauthnComponents.CoseKey.html"},{"type":"module","title":"Example - WebauthnComponents.CoseKey","doc":"```elixir\ndefmodule MyApp.Authentication.UserKey do\n  use Ecto.Schema\n  import Ecto.Changeset\n  alias MyApp.Accounts.User\n  alias WebauthnComponents.CoseKey\n\n  @primary_key {:id, :binary_id, autogenerate: true}\n  @foreign_key_type :binary_id\n  @derive {Jason.Encoder, only: [:key_id, :public_key, :label, :last_used]}\n  schema \"user_keys\" do\n    field :label, :string, default: \"default\"\n    field :key_id, :binary\n    field :public_key, CoseKey\n    belongs_to :user, User\n    field :last_used, :utc_datetime\n\n    timestamps()\n  end\n\n  ...\nend\n```","ref":"WebauthnComponents.CoseKey.html#module-example"},{"type":"function","title":"WebauthnComponents.CoseKey.cast/1","doc":"","ref":"WebauthnComponents.CoseKey.html#cast/1"},{"type":"function","title":"WebauthnComponents.CoseKey.dump/1","doc":"","ref":"WebauthnComponents.CoseKey.html#dump/1"},{"type":"function","title":"WebauthnComponents.CoseKey.embed_as/1","doc":"","ref":"WebauthnComponents.CoseKey.html#embed_as/1"},{"type":"function","title":"WebauthnComponents.CoseKey.equal?/2","doc":"","ref":"WebauthnComponents.CoseKey.html#equal?/2"},{"type":"function","title":"WebauthnComponents.CoseKey.load/1","doc":"","ref":"WebauthnComponents.CoseKey.html#load/1"},{"type":"function","title":"WebauthnComponents.CoseKey.type/0","doc":"","ref":"WebauthnComponents.CoseKey.html#type/0"},{"type":"module","title":"WebauthnComponents.RegistrationComponent","doc":"A LiveComponent for registering a new Passkey via the WebAuthn API.\n\n> Registration = Sign Up\n\nRegistration is the process of creating and associating a new key with a user account.\n\nExisting users may also register additional keys for backup, survivorship, sharing, or other purposes. Your application may set limits on how many keys are associated with an account based on business concerns.\n\nSee [USAGE.md](./USAGE.md) for example code.","ref":"WebauthnComponents.RegistrationComponent.html"},{"type":"module","title":"Assigns - WebauthnComponents.RegistrationComponent","doc":"- `@user`: (**Required**) A `WebauthnComponents.WebauthnUser` struct.\n- `@challenge`: (Internal) A `Wax.Challenge` struct created by the component, used to create a new credential request in the client.\n- `@class` (Optional) CSS classes for overriding the default button style.\n- `@disabled` (Optional) Set to `true` when the `SupportHook` indicates WebAuthn is not supported or enabled by the browser. Defaults to `false`.\n- `@id` (Optional) An HTML element ID.\n- `@require_resident_key` (Optional) Set to `false` to allow non-passkey credentials. Defaults to `true`.","ref":"WebauthnComponents.RegistrationComponent.html#module-assigns"},{"type":"module","title":"Events - WebauthnComponents.RegistrationComponent","doc":"The following events are handled internally by `RegistrationComponent`:\n\n- `\"register\"`: Triggered when a user clicks the `register` button.\n- `\"registration-challenge\"`: Sent from the component to the client to request credential registration for the endpoint URL.\n- `\"registration-attestation\"` Sent by the client when a registration attestation has been created.\n- `\"error\"` Sent by the client when an error occurs.","ref":"WebauthnComponents.RegistrationComponent.html#module-events"},{"type":"module","title":"Messages - WebauthnComponents.RegistrationComponent","doc":"This component handles communication between the client, manages its own state, and communicates with the parent LiveView when registration is successful. Errors are also reported to the parent LiveView when the client pushes an error, or when registration fails.\n\nThe following messages **must be handled by the parent LiveView** using [`Phoenix.LiveView.handle_info/2`](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html#c:handle_info/2):\n\n- `{:registration_successful, key_id: raw_id, public_key: public_key}`\n  - `:key_id` is a raw binary containing the credential id created by the browser.\n  - `:public_key` is a map of raw binaries which may be used later for authentication.\n  - These values must be persisted by the parent application in order to be used later during authentication.\n- `{:registration_failure, message: message}`\n  - `:message` is an exception message returned by Wax when registration fails.\n- `{:error, payload}`\n  - `payload` contains the `message`, `name`, and `stack` returned by the browser upon timeout or other client-side errors.\n\nErrors should be displayed to the user via [`Phoenix.LiveView.put_flash/3`](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html#put_flash/3). However, some errors may be too technical or cryptic to be useful to users, so the parent LiveView may paraphrase the message for clarity.","ref":"WebauthnComponents.RegistrationComponent.html#module-messages"},{"type":"function","title":"WebauthnComponents.RegistrationComponent.handle_event/3","doc":"","ref":"WebauthnComponents.RegistrationComponent.html#handle_event/3"},{"type":"function","title":"WebauthnComponents.RegistrationComponent.mount/1","doc":"","ref":"WebauthnComponents.RegistrationComponent.html#mount/1"},{"type":"function","title":"WebauthnComponents.RegistrationComponent.render/1","doc":"","ref":"WebauthnComponents.RegistrationComponent.html#render/1"},{"type":"function","title":"WebauthnComponents.RegistrationComponent.update/2","doc":"","ref":"WebauthnComponents.RegistrationComponent.html#update/2"},{"type":"module","title":"WebauthnComponents.SupportComponent","doc":"A LiveComponent for detecting WebAuthn support.\n\nThis component should be used in combination with `RegistrationComponent` and `AuthenticationComponent` to disable their buttons when WebAuthn is not supported or enabled.\n\nAn application may also use `SupportComponent` to steer users away from traditional authentication to the more secure Passkey authentication method. For example, an application that supports both traditional authentication and Passkeys may redirect users to a Passkey LiveView or render a message encouraging the new authentication method.\n\nSee [USAGE.md](./USAGE.md) for example code.","ref":"WebauthnComponents.SupportComponent.html"},{"type":"module","title":"Assigns - WebauthnComponents.SupportComponent","doc":"- `@id` (Optional) An HTML element ID.\n- `@passkeys_supported`: (Internal) A boolean indicating the client does or does not support the WebAuthn API.","ref":"WebauthnComponents.SupportComponent.html#module-assigns"},{"type":"module","title":"Events - WebauthnComponents.SupportComponent","doc":"- `\"passkeys-supported\"`: Sent by the client when Passkey support has been checked.","ref":"WebauthnComponents.SupportComponent.html#module-events"},{"type":"module","title":"Messages - WebauthnComponents.SupportComponent","doc":"- `{:passkeys_supported, boolean}`\n  - `boolean` will be `true` when WebAuthn is supported and enabled, and `false` when it is not supported or enabled.","ref":"WebauthnComponents.SupportComponent.html#module-messages"},{"type":"function","title":"WebauthnComponents.SupportComponent.handle_event/3","doc":"","ref":"WebauthnComponents.SupportComponent.html#handle_event/3"},{"type":"function","title":"WebauthnComponents.SupportComponent.mount/1","doc":"","ref":"WebauthnComponents.SupportComponent.html#mount/1"},{"type":"function","title":"WebauthnComponents.SupportComponent.render/1","doc":"","ref":"WebauthnComponents.SupportComponent.html#render/1"},{"type":"module","title":"WebauthnComponents.TokenComponent","doc":"A LiveComponent for handling session tokens.\n\n`TokenComponent` manages the client-side session token, allowing the parent LiveView to do the following:\n\n- Redirect when a user is already signed in.\n- Store a new token upon registration or authentication.\n- Clear a token upon sign-out.\n\nSee [USAGE.md](./USAGE.md) for example code.","ref":"WebauthnComponents.TokenComponent.html"},{"type":"module","title":"Assigns - WebauthnComponents.TokenComponent","doc":"- `@id` (Optional) An HTML element ID.\n- `@token`: A Base64-encoded session token to be stored in the client.\n\nThe parent LiveView may use [`Phoenix.LiveView.send_update/3`](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html#send_update/3) to set or clear a token in the client.\n\n#","ref":"WebauthnComponents.TokenComponent.html#module-assigns"},{"type":"module","title":"Clear a Token - WebauthnComponents.TokenComponent","doc":"```elixir\nsend_update(TokenComponent, id: \"token-component\", token: :clear)\n```\n\n#","ref":"WebauthnComponents.TokenComponent.html#module-clear-a-token"},{"type":"module","title":"Store a Token - WebauthnComponents.TokenComponent","doc":"```elixir\nsend_update(TokenComponent, id: \"token-component\", token: base64_encoded_token)\n```","ref":"WebauthnComponents.TokenComponent.html#module-store-a-token"},{"type":"module","title":"Events - WebauthnComponents.TokenComponent","doc":"The following events are handled internally by `TokenComponent`:\n\n- `\"token-exists\"`: Sent by the client when `sessionStorage` contains a `userToken`.\n- `\"token-stored\"`: Sent by the client when a token has been stored in `sessionStorage`.\n- `\"token-cleared\"`: Sent by the client when a token has been cleared from `sessionStorage`.\n- `\"error\"`: Sent by the client when an error occurs.","ref":"WebauthnComponents.TokenComponent.html#module-events"},{"type":"module","title":"Messages - WebauthnComponents.TokenComponent","doc":"- `{:token_exists, token: token}`\n  - `:token` is a Base64-encoded token found by the client.\n  - The parent LiveView may use this token to authenticate users.\n- `{:token_stored, token: token}`\n  - `:token` is a Base64-encoded token stored by the client.\n  - The parent LiveView may compare the returned token against the token sent to the component to ensure there has been no tampering.\n- `{:token_cleared}`\n  - A token has been cleared from the client.\n- `{:error, payload}`\n  - `payload` contains the `message`, `name`, and `stack` returned by the browser upon timeout or other client-side errors.","ref":"WebauthnComponents.TokenComponent.html#module-messages"},{"type":"function","title":"WebauthnComponents.TokenComponent.handle_event/3","doc":"","ref":"WebauthnComponents.TokenComponent.html#handle_event/3"},{"type":"function","title":"WebauthnComponents.TokenComponent.mount/1","doc":"","ref":"WebauthnComponents.TokenComponent.html#mount/1"},{"type":"function","title":"WebauthnComponents.TokenComponent.render/1","doc":"","ref":"WebauthnComponents.TokenComponent.html#render/1"},{"type":"function","title":"WebauthnComponents.TokenComponent.update/2","doc":"Stores or clears a session token.\n\nWhen a `:token` assign is received, this function will either clear or store the user's token.\n\n- Assign `token: :clear` to remove a user's token.\n- Assign a binary token (typically a base64-encoded crypto hash) to persist a user's token to the browser's `sessionStorage`.\n- Invalid token assigns will be logged and the socket will be returned unchanged.","ref":"WebauthnComponents.TokenComponent.html#update/2"},{"type":"module","title":"WebauthnComponents.WebauthnUser","doc":"Struct representing required fields used by the WebAuthn API.","ref":"WebauthnComponents.WebauthnUser.html"},{"type":"type","title":"WebauthnComponents.WebauthnUser.t/0","doc":"","ref":"WebauthnComponents.WebauthnUser.html#t:t/0"},{"type":"extras","title":"WebauthnComponents","doc":"# WebauthnComponents\n\nA collection of drop-in LiveComponents for password-less authentication.\n\n#","ref":"readme.html"},{"type":"extras","title":"Status: Beta 💅🏻 - WebauthnComponents","doc":"Please **do not use WebauthnComponents in a production environment** until it has completed _beta_ testing.\n\nThis package is a **work in progress**, and it is in early beta status.\n\nFeel free to experiment with this package and contribute feedback through [GitHub discussions](https://github.com/liveshowy/webauthn_components/discussions) or the related topic in [Elixir Forum](https://elixirforum.com/t/webauthnlivecomponent-passwordless-auth-for-liveview-apps/49941).","ref":"readme.html#status-beta"},{"type":"extras","title":"Roadmap - WebauthnComponents","doc":"View the planned work for this repo in the public [WebauthnComponents v1](https://github.com/orgs/liveshowy/projects/3/views/1) project on GitHub.","ref":"readme.html#roadmap"},{"type":"extras","title":"Quick Start - WebauthnComponents","doc":"During the beta phase, generators will be added to streamline initial setup, including running migrations, generating related modules, etc. Steps marked `(TODO)` need additional documentation, and some may be streamlined by Mix tasks during the beta phase.\n\n1. Add Mix dependency\n1. Add `WebAuthn` hook to `app.js`\n1. Run Mix task to create `user_keys` schema & migration\n   - `mix phx.gen.context --binary-id Authentication UserKey user_keys key_id:binary label last_used:utc_datetime public_key:binary user_id:references:users`\n1. Update `UserKey` schema (TODO)\n   - Add default value to the `label` field\n   - Update the `public_key` field to use `WebauthnComponents.CoseKey` as its type\n   - Add `new_changeset/2` & `update_changeset/2` (TODO)\n1. Run Mix task to create `user_tokens` schema & migration\n   - `mix phx.gen.context --binary-id Authentication UserToken user_tokens user_id:references:users token:binary context`\n1. Update `UserToken` schema\n   - Update the `context` field to use `Ecto.Enum` as its type with `values: [:session, :device_code]` and `default: :session`\n   - Replace `user_id` field with `belongs_to` `User` association\n   - Add `foreign_key_constraint` `:user_id`\n   - Add token helper functions (TODO)\n1. Update `User` and/or relevant schemas to include keys association (TODO)\n\n#","ref":"readme.html#quick-start"},{"type":"extras","title":"Installation - WebauthnComponents","doc":"Add `webauthn_components` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:webauthn_components, \"~> 0.5\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - WebauthnComponents","doc":"The schemas, migrations, and contexts required by WebauthnComponents may be generated using the `wac.install` Mix Task:\n\n```bash\n# Generate a new Phoenix app if necessary\nmix phx.new my_app\ncd my_app\n\n# Generate modules for WebauthnComponents\nmix wac.install\n* creating lib/my_app/users/user.ex\n* creating lib/my_app/user_keys/user_key.ex\n* creating lib/my_app/user_tokens/user_token.ex\n* creating priv/repo/migrations/20230709155207_user_keys.ex\n* creating priv/repo/migrations/20230709155207_user_tokens.ex\n* creating priv/repo/migrations/20230709155207_users.ex\n* creating lib/my_app/users.ex\n* creating lib/my_app/user_keys.ex\n* creating lib/my_app/user_tokens.ex\n```\n\nThe `wac.install` task is currently designed for Phoenix apps with no existing authentication. If your application has existing authentication, you may manually add or modify the modules required by `WebauthnComponents`.\n\n\\*Additional generators for authentication and registration LiveViews are planned for a future release.\n\nSee [USAGE.md](./USAGE.md) for detailed usage instructions.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"WebAuthn Flows - WebauthnComponents","doc":"`WebauthnComponents` contains a few modular components which may be combined to detect passkey support, register new keys, authenticate keys for existing users, and manage session tokens in the client.\n\nSee module documentation for each component for more detailed descriptions.","ref":"readme.html#webauthn-flows"},{"type":"extras","title":"Cross-Device Authentication - WebauthnComponents","doc":"When a user attempts to authenticate on a device where their Passkey is **not** stored, they may scan a QR code to use a cloud-sync'd Passkey.\n\n#","ref":"readme.html#cross-device-authentication"},{"type":"extras","title":"Example - WebauthnComponents","doc":"Imagine a user, Amal, registers a Passkey for example.com on their iPhone and it's stored in iCloud. When they attempt to sign into example.com on a non-Apple device or any browser which cannot access their OS keychain, they may choose to scan a QR code using their iPhone. Assuming the prompts on the iPhone are successful, the other device will be authenticated using the same web account which was initially registered on the iPhone.\n\nWhile this example refers to Apple's Passkey implementation, the process on other platforms may vary. Cross-device credential managers like 1Password may provide a more seamless flow for users who are not constrained to one OS or browser.\n\n##","ref":"readme.html#example"},{"type":"extras","title":"Support Detection - WebauthnComponents","doc":"```mermaid\nsequenceDiagram\n   autonumber\n   participant Client\n   participant SupportComponent\n   participant ParentLiveView\n   participant RegistrationComponent\n   participant AuthenticationComponent\n\n   Client->>SupportComponent: \"passkeys-supported\"\n   SupportComponent->>ParentLiveView: `{:passkeys_supported, boolean}`\n   ParentLiveView->>RegistrationComponent: `@disabled = !@passkeys_supported`\n   ParentLiveView->>AuthenticationComponent: `@disabled = !@passkeys_supported`\n```\n\n##","ref":"readme.html#support-detection"},{"type":"extras","title":"Registration - WebauthnComponents","doc":"**Sign Up**\n\n```mermaid\nsequenceDiagram\n   autonumber\n   actor User\n   participant Client\n   participant RegistrationComponent\n   participant ParentLiveView\n\n   User->>Client: Click `register`\n   Client->>RegistrationComponent: \"register\"\n   RegistrationComponent->>Client: \"registration-challenge\"\n   Client->>RegistrationComponent: \"registration-attestation\"\n   RegistrationComponent->>ParentLiveView: `{:registration_successful, ...}`\n```\n\nOnce the parent LiveView receives the `{:registration_successful, ...}` message, it must persist the user, the user's new key. To keep the user signed in, the LiveView may [create a session token](#token-management), Base64-encode the token, and pass it to `TokenComponent` for persistence in the client's `sessionStorage`.\n\n##","ref":"readme.html#registration"},{"type":"extras","title":"Token Management - WebauthnComponents","doc":"**Successful Sign Up / Sign In**\n\n```mermaid\nsequenceDiagram\n   autonumber\n   participant Client\n   participant TokenComponent\n   participant ParentLiveView\n\n   ParentLiveView->>TokenComponent: `@token = b64_token`\n   TokenComponent->>Client: \"store-token\"\n   Client->>TokenComponent: \"token-stored\"\n   TokenComponent->>ParentLiveView: `{:token_stored, ...}`\n```\n\n**Active Session**\n\n```mermaid\nsequenceDiagram\n   autonumber\n   participant Client\n   participant TokenComponent\n   participant ParentLiveView\n\n   Client->>TokenComponent: \"token-exists\"\n   TokenComponent->>ParentLiveView: `{:token_exists, ...}`\n   ParentLiveView-->ParentLiveView: \"[user lookup by token]\"\n```\n\n**Sign Out**\n\n```mermaid\nsequenceDiagram\n   autonumber\n   participant Client\n   participant TokenComponent\n   participant ParentLiveView\n\n   ParentLiveView->>TokenComponent: `@token = :clear`\n   TokenComponent->>Client: \"clear-token\"\n   Client->>TokenComponent: \"token-cleared\"\n   TokenComponent->>ParentLiveView: `{:token_cleared}`\n```\n\n##","ref":"readme.html#token-management"},{"type":"extras","title":"Authentication - WebauthnComponents","doc":"**Sign In**\n\n```mermaid\nsequenceDiagram\n   autonumber\n   actor User\n   participant Client\n   participant AuthenticationComponent\n   participant ParentLiveView\n\n   User->>Client: Click `authenticate`\n   Client->>AuthenticationComponent: \"authenticate\"\n   AuthenticationComponent->>Client: \"authentication-challenge\"\n   Client->>AuthenticationComponent: \"authentication-attestation\"\n   AuthenticationComponent->>ParentLiveView: `{:find_credential, ...}`\n```\n\nOnce the parent LiveView receives the `{:find_credential, ...}` message, it must lookup the user via the user's existing key. To keep the user signed in, the LiveView may [create a session token](#token-management), Base64-encode the token, and pass it to `TokenComponent` for persistence in the client's `sessionStorage`.","ref":"readme.html#authentication"},{"type":"extras","title":"WebAuthn & Passkeys - WebauthnComponents","doc":"> The Web Authentication API is an extension of the Credential Management API that enables strong authentication with public key cryptography, enabling passwordless authentication and/or secure second-factor authentication without SMS texts.\n>\n> https://developer.mozilla.org/en-US/docs/Web/API/Web_Authentication_API\n\n> A passkey is a FIDO login credential, tied to an origin (website or application) and a physical device. Passkeys allow users to authenticate without having to enter a username, password, or provide any additional authentication factor. This technology aims to replace passwords as the primary authentication mechanism.\n>\n> https://developers.google.com/identity/fido\n\nPasskeys are essentially a standard to sync WebAuthn credentials with cloud platforms like [iCloud Keychain](https://developer.apple.com/passkeys/), [Android](https://developers.google.com/identity/fido), [1Password](https://blog.1password.com/1password-is-joining-the-fido-alliance/), with more to come.\n\n#","ref":"readme.html#webauthn-passkeys"},{"type":"extras","title":"Benefits - WebauthnComponents","doc":"There are many benefits to users and application maintainers when passwords are decommissioned.\n\n- Eliminates password reuse by users.\n- Mitigates credential stuffing attacks by hackers.\n- Eliminates phishing attacks by hackers.\n\nFor users on a device with Passkey support, WebAuthn credentials may be stored in the cloud. This allows the user to authenticate from other cloud-connected devices without registering each device individually.\n\n#","ref":"readme.html#benefits"},{"type":"extras","title":"Known Issues - WebauthnComponents","doc":"While WebAuthn provides an API for improved authentication security, there are a few limitations to consider before adopting this component.\n\n- As of 2022, Passkeys are not universally supported.\n- If a user registers or authenticates on a device without Passkey support, the generated key pair will not be synced, and each device must be registered in order to access an account.\n- Cloud-synced credentials are only accessible to devices authenticated to the cloud account.\n  - For example, a credential saved to iCloud Keychain will not be synced automatically to Android's credential manager.","ref":"readme.html#known-issues"},{"type":"extras","title":"Browser Support - WebauthnComponents","doc":"The WebAuthn API has broad support across the most common modern browsers.\n\nhttps://caniuse.com/?search=webauthn","ref":"readme.html#browser-support"},{"type":"extras","title":"Additional Resources - WebauthnComponents","doc":"- https://webauthn.guide/\n- https://developer.mozilla.org/en-US/docs/Web/API/Web_Authentication_API\n- https://fidoalliance.org/fido2-2/fido2-web-authentication-webauthn/\n- https://www.w3.org/TR/webauthn-2/","ref":"readme.html#additional-resources"},{"type":"extras","title":"Usage","doc":"# Usage\n\n`WebauthnComponents` are designed to be modular, providing flexibility to developers. However, `SupportComponent` should always be rendered along with `RegistrationComponent` and `AuthenticationComponent` to detect WebAuthn support on the client.\n\nA parent LiveView may also want to redirect users or clear tokens when users enter a page using the registration or authentication component. In these cases, render `TokenComponent` and implement its required message handlers to manage client-side session tokens.","ref":"usage.html"},{"type":"extras","title":"Contents - Usage","doc":"- [Usage](#usage)\n  - [Contents](#contents)\n  - [Combined Example](#combined-example)\n  - [SupportComponent](#supportcomponent)\n  - [TokenComponent](#tokencomponent)\n  - [RegistrationComponent](#registrationcomponent)\n  - [Authentication Component](#authentication-component)","ref":"usage.html#contents"},{"type":"extras","title":"Combined Example - Usage","doc":"The following `AuthLive` example demonstrates how to compose the components to detect support, register, authenticate, and manage tokens in a single LiveView.\n\n \n\n```elixir\ndefmodule MyAppWeb.AuthLive do\n  use Phoenix.LiveView\n  alias WebauthnComponents.AuthenticationComponent\n  alias WebauthnComponents.RegistrationComponent\n  alias WebauthnComponents.SupportComponent\n  alias WebauthnComponents.TokenComponent\n\n  def mount(_session, _params, socket) do\n    {\n      :ok,\n      socket\n      |> assign(:passkeys_supported, fn -> nil end)\n    }\n  end\n\n  def render(assigns) do\n    ~H\"\"\"\n     \n       Sign Up \n\n       \n\n       \n     \n    \"\"\"\n  end\n\n  def handle_info({:passkeys_supported, true}, socket) do\n    {\n      :noreply,\n      socket\n      |> assign(:passkeys_supported, true)\n    }\n  end\n\n  def handle_info({:passkeys_supported, false}, socket) do\n    {\n      :noreply,\n      socket\n      |> assign(:passkeys_supported, false)\n      |> put_flash(:error, \"Sorry, passkeys are not supported or enabled by this browser.\")\n    }\n  end\n\n  def handle_info({:registration_successful, key_id: raw_id, public_key: public_key}, socket) do\n    # Persist the user here.\n  end\n\n  def handle_info({:registration_failure, message: message}, socket) do\n    # Display the error message.\n  end\n\n  def handle_info({:error, payload}, socket) do\n    # Display the error message.\n  end\nend\n```","ref":"usage.html#combined-example"},{"type":"extras","title":"SupportComponent - Usage","doc":"On its own, `SupportComponent` only reports whether the WebAuthn API is supported and enabled by the client. This may be useful for redirecting users away from traditional authentication for businesses mandating Passkey usage whenever possible.","ref":"usage.html#supportcomponent"},{"type":"extras","title":"TokenComponent - Usage","doc":"","ref":"usage.html#tokencomponent"},{"type":"extras","title":"RegistrationComponent - Usage","doc":"","ref":"usage.html#registrationcomponent"},{"type":"extras","title":"Authentication Component - Usage","doc":"","ref":"usage.html#authentication-component"}],"content_type":"text/markdown"}